<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* ε 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

	require_once "lib/Common.php";
	require_once "lib/Article.php";
	require_once "lib/String.php";
	require_once "lib/Session.php";
	require_once "lib/Security.php";
	require_once "lib/SQL.php";
	require_once "lib/Parts.php";
	require_once "lib/Template.php";

	//   
	require_once "constants.php";

	if(!$settings->admin)
		redirect("setup.php");

	if(!$_GET[id])
		alert($settings->messages[no_board]);

	$session = new Session($settings);

	$has_session = $session->hasSession();

	// ڵ α   α
	if(!$has_session && $session->getcookie("login_info"))
		redirect(LINK_PATH . "session.php?mode=login&href=" . urlencode(LINK_PATH . "?" . $_SERVER[QUERY_STRING]));

	$sql = new SQL($settings);

	// DB 
	$connection = $sql->db->connect($sql->dsn);

	// ASSOC  Fetch mode 
	$connection->setFetchMode(DB_FETCHMODE_ASSOC);

	if(DB::isError($connection))
		alert($connection->getMessage());


	// Խ 

	$query = "select config.*, grp.access_level as access_level, grp.denied_ip as denied_ip, grp.allow_ip as allow_ip, grp.allow_joining as allow_joining from " . $settings->prefix . "_board_config as config ";
	$query .= " left outer join " . $settings->prefix . "_group as grp on config.gid = grp.gid ";
	$query .= "where config.id=" . $_GET[id];

	$result = $connection->query($query);

	if(DB::isError($result) || $result->numRows() < 1)
		alert($settings->messages[failed_to_get_config] . " on " . __FILE__ . " line " . __LINE__);

	$config = $result->fetchRow(DB_FETCHMODE_ASSOC);

	// Ų 
	$skin_path = $settings->skin_path . $config[skin] . "/";

	define("SKIN_PATH", LINK_PATH . "skins/" . $config[skin] . "/");

	// Ų  ҷ
	if(file_exists($skin_path . "skin.ini"))
	{
		$config_skin = parse_ini_file($skin_path . "skin.ini");

		$config = array_merge($config, $config_skin);

		unset($config_skin);
	}

	if($config[width] <= 100)
		$config[width] = $config[width] . "%";


	//   IP 
	if($config[denied_ip] || $config[allow_ip])
	{
		if(!$config[allow_ip])
			$ip_list = $config[denied_ip];
		else
			$ip_list = $config[allow_ip];

		$ip_list = explode(",",$ip_list);

		foreach($ip_list as $ip)
		{
			if((!$config[allow_ip] && ereg("^" . $ip . ".*", $_SERVER[REMOTE_ADDR])) || ($config[allow_ip] && !ereg("^" . $ip . ".*",$_SERVER[REMOTE_ADDR])))
				$flag = true;
			else
				$flag = false;
		}

		if($flag)
			alert($settings->messages[ip_denied]);
	}	
	

	
	//  
	$result = $connection->query("select * from " . $settings->prefix . "_board_privileges where id=" . $_GET[id]);

	if(DB::isError($result))
		alert($settings->messages[failed_to_get_config] . " " . $result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

	$grant = $result->fetchRow(DB_FETCHMODE_ASSOC);




	//  ľ
	if($has_session)
	{
		//       
		$member = $connection->getRow("select * from " . $settings->prefix . "_member where email = '" . $session->get("email") . "'");

		if($session->get("email") == $settings->admin)
			$my_grant = USER_ADMINISTRATOR;
		else if ($session->get("email") == $config[administrator])
			$my_grant = USER_SYSOP;
		else
		{
			$authorized = $connection->getOne("select authorized from " . $settings->prefix . "_group_members where gid = " . $config[gid] . " and email = '" . $session->get("email") ."'");

			if(!DB::isError($authorized) && $authorized > 0)
			{
				$my_grant = USER_AUTHORIZED_MEMBER;
			}
			else if(!DB::isError($authorized) && isset($authorized) && $authorized == "0")
				$need_auth = true;
			else
				$my_grant = USER_MEMBER;
		}
	}
	else
		$my_grant = USER_NORMAL;

	//   ȵ 
	if($config[access_level] && $my_grant < $config[access_level])
	{
		//    ->  
		if(!$has_session) 
			alert($settings->messages[session_missing], LINK_PATH . "session.php?href=" . LINK_NAME . "?" . $_SERVER[QUERY_STRING]);
		// ׷쿡   ̳  ʿ 
		else if($need_auth)
			alert($settings->messages[require_auth]);
		// ׷쿡   
		else if($has_session && $my_grant == USER_MEMBER && $config[allow_joining])
			redirect(LINK_PATH . "joining.php?mode=group&id=" . $config[gid] . "&href=" . LINK_NAME . "?" . $_SERVER[QUERY_STRING]);
		//   Ǿ  
		else
			alert($settings->messages[no_grant_access]);
	}






	// 亯  
	if($my_grant >= $grant[grant_reply] || !$grant[grant_reply])
		$repliable = true;
	//  ۼ  
	if($my_grant >= $grant[grant_post] || !$grant[grant_post])
		$writable = true;
	// б  
	if($my_grant >= $grant[grant_read] || !$grant[grant_read])
		$readable = true;
	//   
	if($my_grant > 3)
		$administratable = true;
	// 亯  
	if(!$grant[grant_reply] || $my_grant > $grant[grant_reply])
		$repliable = true;






	// Ʈ
	$points = parse_ini_file($path."conf/points.ini");

	// ¥ ǥ 
	$date_format = parse_ini_file($path."conf/date_format.ini");

	if($config["header_file"] && file_exists($config["header_file"]))
	{
		$fp = fopen($config["header_file"], "rb");
		$header = fread($fp, filesize($config["header_file"]));
		fclose($fp);
	}
	else if(file_exists($skin_path . "header.html"))
	{
		$tpl = new Template($skin_path);

		$tpl->loadTemplatefile("header.html",true, true);

		$tpl->setVariable("TITLE", $config[name]);

		$tpl->setVariable("BACKGROUND", $config[background]);

		$tpl->setVariable("BGCOLOR",$config[bgcolor]);

		$tpl->setVariable("ENCODING",$settings->encoding);


		// ޼ ȯ
		foreach($settings->messages as $key => $val)
		{
			$tpl->setVariable("MSG_" . strtoupper($key), $val);
		}

		
		// 
		$header = $tpl->get();
	}

	$header .= "\n\n<script type=\"text/javascript\" src=\"" . JS_PATH . "/lib.php?id=" . $_GET[id] . "\"></script>";


	// Ǫ
	if($config["footer_file"] && file_exists($config["footer_file"]))
	{
		$fp = fopen($config["footer_file"], "rb");
		$footer = fread($fp, filesize($config["footer_file"]));
		fclose($fp);
	}
	else if(file_exists($skin_path . "footer.html"))
	{
		$tpl = new Template($skin_path);

		$tpl->loadTemplatefile("footer.html",true, true);

		// ޼ ȯ
		foreach($settings->messages as $key => $val)
		{
			$tpl->setVariable("MSG_" . strtoupper($key), $val);
		}


		// ũƮ  ð
		$tpl->setVariable("EXECUTE_TIME",get_exec_time());

		$footer = $tpl->get();
	}

	clearstatcache();

	$query_string = eregi_replace("\&page=.+","",$_SERVER[QUERY_STRING]);

	switch($_GET[module])
	{
		//  
		case "member_info" :
		// ڱ 
		case "myinfo" :
		// ڸƮ
		case "comment" : 
		// ۾
		case "write" : 
		// ۺ
		case "view" : 
		//  ٿε
		case "download" :
		// Խù ̵
		case "move" :
		//  ߼
		case "send_mail" :
		// RSS
		case "rdf" :
			include $_GET[module] . ".php";
			break;

		// Ʈ
		default :

			include "list.php";
	}

	// DB  
	$connection->disconnect();
?>