<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* ȸ 
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

	require_once "lib/Common.php";
	require_once "lib/SQL.php";
	require_once "lib/String.php";
	require_once "lib/Session.php";
	require_once "lib/Security.php";
	require_once "lib/File.php";
	require_once "lib/Email.php";
	require_once "lib/Template.php";

	require_once "constants.php";

	$session = new Session($settings);

	$has_session = $session->hasSession();

	$sql = new SQL($settings);

	$connection = $sql->db->connect($sql->dsn);

	if(DB::isError($connection))
		alert($connection->getMessage());

	$schema_xml = $settings->path."lib/schema.xml.php";

	$href = $_GET[href];

	if(!$href)
		$href = $_POST[href];

	// ̼   Referer  
	if(!$href)
		$href = $_ENV[HTTP_REFERER];

	$mode = $_GET["mode"];

	$login_info = $session->getcookie("login_info");

	$connection->setFetchMode(DB_FETCHMODE_ASSOC);

	switch($mode)
	{
		// 
		case "joining" :

			if($session->hasSession())
				alert($settings->messages[already_login]);

			if(!$_POST)
				alert($settings->messages[invalid_access]);

			if($_POST[password] != $_POST[password_confirm])
				alert($settings->messages[password_mismatch]);

			$user = $_POST;

			$user[birth_date] = str_replace("-","",$user[birth_date]);
			$user[homepage] = String::checkUrl($user[homepage]);
			$user[password] = Security::encrypt($user[password]);
			$user[joining_date] = 0;
			$user[photo] = $_FILES[photo][name];

			require_once "lib/XPath.php";

			// Database Schema Loading...	
			$xpath = new XPath($schema_xml);

			// Field loading
			$i = 1;
			// "/fboardx/table[1]" -> ȸ  ̺
			while($xpath->match("/" . $settings->prefix . "/table[1]/field-list/field[$i]"))
			{
				$current_path = "/" . $settings->prefix . "/table[1]/field-list/field[$i]";

				$fields[] = $xpath->getData($current_path);

				$i++;
			}

			$i = 1;
			// "/fboardx/table[2]" -> ȸ ΰ  ̺
			while($xpath->match("/" . $settings->prefix . "/table[2]/field-list/field[$i]"))
			{
				$current_path = "/" . $settings->prefix . "/table[2]/field-list/field[$i]";

				$ext_fields[] = $xpath->getData($current_path);

				$i++;
			}

			//  ε
			if($user[photo])
			{
				$user[photo] = urlencode($user[email]) . "." . File::getExtension($_FILES[photo][name]);

				if($_FILES[photo][size] && !uploadImage("photo", $user[photo]))
					alert($settings->messages[upload_failed]);
			}

			// ȿ ʵ 
			$values = $sql->getValidValues($user, $fields);
			$ext_values = $sql->getValidValues($user, $ext_fields);

			$values[point] = "0";
			$values[status] = "0";

			// DB Է
			$result = $connection->autoExecute($settings->prefix . "_member",$values);

			if(DB::isError($result))
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			// ΰ  DB Է
			$result = $connection->autoExecute($settings->prefix . "_member_ext",$ext_values);

			if(DB::isError($result))
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			// Ʈ DB  Է
			$values = array("email" => $user[email]);

			$result = $connection->autoExecute($settings->prefix . "_point",$values);

/*
			$session->set("email", $user[email]);
			$session->set("password", $user[password]);
			$session->set("name", $user[name]);
*/
			if(DB::isError($result))
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			// Email ּ Ȯ  ߼
			$mail = new Email($settings);

			$url = "http://".$_SERVER[HTTP_HOST].$_SERVER[SCRIPT_NAME]."?mode=verify&href=" . urlencode($href) . "&VE=" . urlencode(md5($user[email]) . "&" . $user[password]);

			//  
			$tpl = new Template($settings->skin_path . "_system");

			$tpl->loadTemplatefile("mail_verify_email.html",true, true);

			$tpl->setVariable("URL", $url);

			$tpl->setVariable("ADMIN_EMAIL", $settings->admin);

			$tpl->setVariable("ENCODING", $settings->encoding);

			$mail->subject = $settings->messages[email_verification];
			$mail->body = $tpl->get();
			$mail->receiver_name = $user[name];
			$mail->receiver_email = $user[email];
			$mail->sender_name = $settings->admin;
			$mail->sender_email = $settings->admin;
			$mail->reply_to = $settings->admin;
			$mail->content_type = "text/html";
			$mail->charset	= $settings->encoding;
			if(!$mail->send())
				alert($settings->messages[send_mail_failed]);

			$tpl->loadTemplatefile("require_email_verification.html",true, true);

			$tpl->setVariable("EMAIL", $user[email]);
			$tpl->setVariable("HREF", $href);
			$tpl->setVariable("SEND_LINK", LINK_PATH . "joining.php?mode=request_verify&email=" . $user[email] . "&href=" . urlencode($href));

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$tpl->setVariable("ENCODING", $settings->encoding);

			$tpl->show();

			break;

		case "request_verify" :

			$user = $connection->getRow("select name, md5(email) as email, password from " . $settings->prefix . "_member where email = '" . $_GET[email] . "'");

			if(!$user || DB::isError($user))
			{
				alert($settings->messages[email_not_found]);
			}

			// Email ּ Ȯ  ߼
			$mail = new Email($settings);

			$url = "http://".$_SERVER[HTTP_HOST].$_SERVER[SCRIPT_NAME]."?mode=verify&href=" . urlencode($href) . "&VE=" . urlencode($user[email] . "&" . $user[password]);
			//  
			$tpl = new Template($settings->skin_path . "_system");

			$tpl->loadTemplatefile("mail_verify_email.html",true, true);

			$tpl->setVariable("URL", $url);

			$tpl->setVariable("ADMIN_EMAIL", $settings->admin);

			$tpl->setVariable("ENCODING", $settings->encoding);

			$mail->subject = $settings->messages[email_verification];
			$mail->body = $tpl->get();
			$mail->receiver_name = $user[name];
			$mail->receiver_email = $user[email];
			$mail->sender_name = $settings->admin;
			$mail->sender_email = $settings->admin;
			$mail->reply_to = $settings->admin;
			$mail->content_type = "text/html";
			$mail->charset	= $settings->encoding;
			$mail->send();

			$tpl->loadTemplatefile("require_email_verification.html",true, true);

			$tpl->setVariable("EMAIL", $_GET[email]);
			$tpl->setVariable("HREF", $href);
			$tpl->setVariable("SEND_LINK", LINK_PATH . "joining.php?mode=request_verify&email=" . $_GET[email] . "&href=" . urlencode($href));


			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$tpl->setVariable("ENCODING", $settings->encoding);

			$tpl->show();

			break;

		case "verify" :


			$info = explode("&", $_GET[VE]);
			$email = $info[0];
			$password = $info[1];


			$result = $connection->getOne("select joining_date from " . $settings->prefix . "_member where md5(email) = '" . $email . "'");
			
			if($result > 0)
				alert($settings->messages[already_verified],LINK_PATH . "session.php?href=" . stripslashes($_GET[href]));

			$values = array("joining_date" => time());

			$result = $connection->autoExecute($settings->prefix . "_member", $values, DB_AUTOQUERY_UPDATE, " md5(email) = '" . $email . "' and password = '" . $password . "'");

			if(DB::isError($result))
				alert($settings->messages[invalid_access]);
			
			alert($settings->messages[email_verified], LINK_PATH . "session.php?href=" . stripslashes($_GET[href]));

			break;

		case "retire" :

			if(!$has_session)
				alert($settings->messages[session_missing]);

			if($session->get("email") == $settings->admin)
				alert($settings->messages[admin_cannot_retire]);

			// ׷쿡 
			$result = $connection->query("delete from " . $settings->prefix . "_group_members where email='" . $session->get("email") . "'");

			// Խù  
			$result = $connection->query("select id from " . $settings->prefix . "_board_config");

			while($row = $result->fetchRow(DB_FETCHMODE_OREDERED))
			{
				$connection->query("update " . $settings->prefix . "_" . $row[0] . "_board set members = '0', password = '" . $session->get("password") . "' where email='" . $session->get("email") ."' and members = '1'");

				$connection->query("update " . $settings->prefix . "_" . $row[0] . "_comment set members = '0', password = '" . $session->get("password") . "' where email='" . $session->get("email") ."' and members = '1'");
			}

			//  ̺ 
			$result = $connection->query("delete from " . $settings->prefix . "_member where email='" . $session->get("email") . "'");

			//  ̺ 
			$result = $connection->query("delete from " . $settings->prefix . "_member_ext where email='" . $session->get("email") . "'");

			if($session->getcookie("login_info"))
				deletecookie("login_info");

			$session->destroy();

			alert($settings->messages[retired],stripslashes($_GET[href]));

			break;

		// ׷ 
		case "group_joining" :

			//   Ȯ
			$joinned = $connection->getOne("select count(1) from " . $settings->prefix . "_group_members where gid = " . $_GET[gid] . " and email = '" . $session->get("email") . "'");

			if($joinned > 0)
				alert($settings->messages[already_joinned]);

			$values = array("gid" => $_GET[id], "email" => $session->get("email"), "authorized" => "0");

			$result = $connection->autoExecute($settings->prefix . "_group_members",$values);

			if(DB::isError($result))
				alert($result->getMessage() . " on " . __FILE__ . " line " . __LINE__);

			alert($settings->messages[joining_succeed], $href);

			break;

		// ׷  
		case "group" :

			//   Ȯ
			$joinned = $connection->getOne("select count(1) from " . $settings->prefix . "_group_members where gid = " . $_GET[gid] . " and email = '" . $session->get("email") . "'");

			if($joinned > 0)
				alert($settings->messages[already_joinned]);

			$group_name = $connection->getOne("select name from " . $settings->prefix . "_group where gid = " . $_GET[gid]);


			$tpl = new Template($settings->skin_path . "_system");

			$tpl->loadTemplatefile("joining_group.html",true, true);

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$tpl->setVariable("ENCODING", $settings->encoding);
			$tpl->setVariable("HREF", $href);
			$tpl->setVariable("ACTION", LINK_PATH . "joining.php?mode=group_joining&gid=" . $_GET[id] . "&href=" . urlencode($href));
			$tpl->setVariable("GROUP_NAME", $group_name);
			$tpl->setVariable("GROUP_ID", $_GET[gid]);
			// ũƮ  ð
			$tpl->setVariable("EXECUTE_TIME",get_exec_time());

			$tpl->show();			

			break;
		
		//  
		default :

			if($session->hasSession())
				alert($settings->messages[already_login]);

			$tpl = new Template($settings->skin_path . "_system");

			$tpl->loadTemplatefile("joining.html",true, true);

			// ޼ ȯ
			foreach($settings->messages as $key => $val)
			{
				$tpl->setVariable("MSG_" . strtoupper($key), $val);
			}

			$tpl->setVariable("ENCODING", $settings->encoding);
			$tpl->setVariable("HREF", $href);
			$tpl->setVariable("ACTION", LINK_PATH . "joining.php?mode=joining&href=" . urlencode($href));
			$tpl->setVariable("EMAIL", $login_info[email]);
			$tpl->setVariable("PASSWORD", $login_info[password]);
			// ũƮ  ð
			$tpl->setVariable("EXECUTE_TIME",get_exec_time());

			$tpl->show();
	}


	$connection->disconnect();

	//   ε
	function uploadImage($file_key, $filename)
	{
		global $settings;

		if (!is_uploaded_file($_FILES[$file_key]['tmp_name']))
			return false;
		 
		$_FILES[$file_key]['tmp_name'] = str_replace("\\\\","\\",$_FILES[$file_key]['tmp_name']);

		if(!File::isUploadedImage($_FILES[$file_key]))
			return false;

		if(move_uploaded_file($_FILES[$file_key]['tmp_name'],$settings->uploaded_file_path."/_photos/" . $filename))
			return true;

		return false;
	}
?>