<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Խù Ŭ
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/

class Article
{
	var $id = "";
	var $num = "";
	var $_connection;
	var $_prefix = "";
	var $_admin	= "";
	var $data;


    /**
     * 
     *
	 * @param object Settings $settings  ü
     *
	 * @param object Connection $this->_connection DB  ü
     *
	 * @param int $id Խ ID
     *
	 * @param int $num Խù ȣ
	 *
     * @return array Խù 迭 (ASSOC)
     *
     * @access public
     */
	function Article($settings, $connection, $id, $num = "")
	{
		$this->_connection = $connection;
		$this->id	= $id;
		$this->num	= $num;
		$this->_prefix	= $settings->prefix;
		$this->_admin	= $settings->admin;

		if($num)
			$this->data = $this->getData($num);

	}

	function setNum($num)
	{
		$this->num = $num;
	}

	function getData($num)
	{
		$query_state = " from " . $this->_prefix . "_" . $this->id . "_board as board ";

		$query_state .= " left outer join " . $this->_prefix . "_category as category on board.category = category.num ";

		$query_state .= " left outer join " . $this->_prefix . "_member as member on board.email = member.email ";

		$query_state .= " left outer join " . $this->_prefix . "_member_ext as member_ext on board.email = member_ext.email ";

		// ڵ Select 
		$query = "select board.*, category.label as category_label, member.name as member_name, member.email as member_email, member.homepage as member_homepage, member.sign " . $query_state;

//			$query = "select * from " . $this->_prefix . "_" . $_GET[id] . "_board as board ";

		$query .= " where board.num=" . $num;

		$result = $this->_connection->query($query);

		if(DB::isError($result))
			return false;

		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);

		$result->free();

		return $row;
	}

	function getGrant($config, $data = "")
	{
		if(!$data)
			$data = $this->data;

		if(!$data[members])
			return USER_NORMAL;
		
		if($data[email] == $this->_admin)
			return USER_ADMINISTRATOR;
		else if ($data[email] == $config[administrator])
			return USER_SYSOP;
		else
		{
			$authorized = $this->_connection->getOne("select count(1) from " . $this->_prefix . "_group_members where gid = " . $config[gid] . " and email = '" . $data[email] . "' and authorized = 1");

			if(!DB::isError($authorized) && $authorized > 0)
			{
				return USER_AUTHORIZED_MEMBER;
			}
			else
				return USER_MEMBER;
		}
	}

	function getParent()
	{
		$result = $this->_connection->limitQuery("select * from " . $this->_prefix . "_" . $_GET[id] . "_board where num=" . abs($this->data[parent]), 0, 1);

		if(DB::isError($result))
			return false;

		$row = $result->fetchRow(DB_FETCHMODE_ASSOC);

		$result->free();

		return $row;
	}

    /**
     * ÷   
     *
     * @return array ÷  
     *
     * @access public
     */
	function getAttachFileInfo()
	{
		if(!$this->num)
			return false;

		$file_info = array();

		$result = $this->_connection->query("select * from " . $this->_prefix . "_files where board_id=" . $this->id . " and board_num= " . $this->num . " order by seq ");

		if(DB::isError($result))
			return false;

		while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$file_info[] = $row;
		}

		$result->free();

		return $file_info;
	}

    /**
     * īװ
     *
     * @return array īװ
     *
     * @access public
     */
	function getCategories()
	{
		$result = $this->_connection->query("select num, label from " . $this->_prefix . "_category where id='" . $this->id . "' order by num");

		if(DB::isError($result))
			return false;

		$categories = array();

		while($row = $result->fetchRow(DB_FETCHMODE_ASSOC))
		{
			$categories[] = $row;
		}

		$result->free();

		return $categories;
	}
}