<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* ̹  
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/
require_once "Image/Transform.php";

class Image
{	
    /**
     *   
     *
	 * @param array $config Խ  ü
	 *
	 * @param string $filename    ϸ  
	 *
     * @return array     ü
     *
     * @access public
     */
	function getThumbnail($config, $filename)
	{
		if($config[lib_path])
			define('IMAGE_TRANSFORM_LIB_PATH', trim($config[lib_path]));

		//   ڵ 
		if(!$config[thumb_height] || $config[thumb_maintain_aspect_ratio])
		{
			$imgsize = GetImageSize($filename);
			$height = ($imgsize[1] / $imgsize[0]) * $config[thumb_width];
		}
		else
			$height = $config[thumb_height];

		$im = Image_Transform::factory($config[driver]);

		$im->load($filename);

		$thumb_name = dirname($filename) . "/thumb_" . basename($filename);

		// next will resize so that the largest length is 300px - height or width
		$im->resize($config[thumb_width], $height);
		//$im->display();
		$im->save($thumb_name);
		// Now free the memory - should be called free?
		$im->free();

		return $thumb_name;
	}
}
?>