<?php
/**
* +----------------------------------------------------------------------+
* | F Board                                                              |
* +----------------------------------------------------------------------+
* | Copyright (c) 2003 Fguy (http://fguy.com)                            |
* +----------------------------------------------------------------------+
* | This software licensed under the GPL license and is provided "as is" |
* | and is without any warranty.                                         |
* |                                                                      |
* | You need to purchase commercial licenses:                            |
* |                                                                      |
* | 1. If you distribute this Software with your non open source         |
* |    software.                                                         |
* | 2. If you want warranty for this software.                           |
* | 3. If you want to support development.                               |
* |                                                                      |
* | Licenses, Support and Training can be easily purchased online.       |
* +----------------------------------------------------------------------+
* | Author: Kang Tae Hoon <fguy@fguy.com>                                |
* +----------------------------------------------------------------------+
*
* Session function library.
*
* @author fguy <fguy@fguy.com>
* @version 0.5
* @access public
* @package FBoard
*/


class Session
{
    /**
     *   
     *
	 * @param string $key  Ű
	 *
     * @return mixed  
     *
     * @access public
     */
	function get($key)
	{
		global $HTTP_SESSION_VARS;

		return $HTTP_SESSION_VARS[$key];
	}

    /**
     *   
     *
	 * @param string $key  Ű
	 *
	 * @param mixed $value  
	 *
     * @access public
     */
	function set($key, $value)
	{
		global $HTTP_SESSION_VARS;

		$HTTP_SESSION_VARS[$key] = $value;
	}


    /**
     *   
     *
	 * @param string $key  Ű
	 *
     * @access public
     */
	function remove($key)
	{
		global $HTTP_SESSION_VARS;

		$HTTP_SESSION_VARS[$key] = NULL;
	}

    /**
     *  ı
     *
     * @access public
     */
	function destroy()
	{
		session_destroy();
	}

    /**
     * ǰ  ƴ Ȯ
     *
	 * @param string $key  Ű
	 *
	 * @return bool   
	 *
     * @access public
     */
	function isRegistered($key)
	{
		return session_is_registered($key);
	}

    /**
     * Ű   
     *
	 * @param string $key Ű ̸
	 *
	 * @return mixed Ű 
	 *
     * @access public
     */
	function getcookie($key)
	{
		global $HTTP_COOKIE_VARS;
	
		$value = $HTTP_COOKIE_VARS[$key];

		return $value;
	}

    /**
     * Ű 
     *
	 * @param string $key Ű ̸
	 *
	 * @return bool  
	 *
     * @access public
     */
	function deletecookie($key)
	{
		if(setcookie($key,"0",time()+0))
			return true;
		return false;
	}

    /**
     *   (뷮 0  ) 
     *
	 * @param string $session_save_path    
	 *
     * @access public
     */
	function removeGarbageSessions($session_save_path = "sessions")
	{
		$_dir = @opendir($session_save_path);

		while($_rdir = @readdir($_dir))
		{
			$_file = $session_save_path . "/". $_rdir;

			if(@filesize($_file) == 0)
				@unlink($_file);
		}
	}

    /**
     * 
     *
     * @access public
     */
	function Session($settings)
	{
		$_session_save_path = $settings->session_save_path;

		$this->removeGarbageSessions($_session_save_path);

		session_name($settings->prefix . "_session");
		session_save_path($_session_save_path);
		//  ĳ    ñ
		session_cache_limiter(""); 
		session_start();
	}

    /**
     *  ϴ  Ȯ
     *
	 * @param object Session $session   ü
	 *
	 * @return bool   
	 *
     * @access public
     */
	function hasSession()
	{
		if($this->isRegistered("email") && $this->isRegistered("password") && $this->isRegistered("name"))
			return true;
		return false;
	}

    /**
     *   (hasSession  )
     *
	 * @param object Settings $settings   ü
	 *
	 * @param object Session $session   ü
	 *
	 * @param object Connection $connection  ̽  ü
	 *
	 * @return bool  缺 
	 *
     * @access public
     */
	function isVaildSession($settings, $connection)
	{
		if($this->hasSession())
		{
			$result = $connection->getOne("select count(1) from " . $settings->prefix . "_member where email='" . $this->get("email") . "' and password = '" . $this->get("password") . "'");

			if(DB::isError($result))
				return false;
			else if($result > 0)
				return true;
		}
		return false;
	}

    /**
     *     Ȯ
     *
	 * @param object Session $session   ü
	 *
	 * @return bool   
	 *
     * @access public
     */
	function isAdmin()
	{
		if($this->hasSession())
			return $this->get("is_admin");
		return false;
	}
}
?>